unit FindDialog;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ExtCtrls, Buttons,SynEditTypes,LCLType;

const
  FD = 'Suchen';
  ED = 'Ersetzten';

type
  { TFindFrom }
  TFindFrom = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    CheckGroup1: TCheckGroup;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    DialogTyp:Boolean;
    function GetOptions: TSynSearchOptions;
    procedure SwitshDialog;
    { public declarations }
  end; 

var
  FindFrom: TFindFrom;

implementation

{ TFindFrom }

procedure TFindFrom.FormShow(Sender: TObject);
begin
  ModalResult:=mrNone;
end;

procedure TFindFrom.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_RETURN then ModalResult:=mrOK;
  if key = VK_ESCAPE then ModalResult:=mrCancel;
end;

procedure TFindFrom.FormCreate(Sender: TObject);
begin
  DialogTyp:=False;
end;

function TFindFrom.GetOptions: TSynSearchOptions;
begin
  Result:=[];
  if CheckGroup1.Checked[0] then Include(Result,ssoMatchCase);
  if CheckGroup1.Checked[1] then Include(Result,ssoWholeWord);
  if CheckGroup1.Checked[2] then Include(Result,ssoRegExpr);
  if CheckGroup1.Checked[3] then Include(Result,ssoRegExprMultiLine);

  if RadioGroup1.ItemIndex = 1 then Include(Result,ssoEntireScope);
  if RadioGroup2.ItemIndex = 2 then include(Result,ssoSelectedOnly);
  if RadioGroup3.ItemIndex = 3  then include(Result,ssoBackwards);

  if ComboBox2.Enabled then include(Result,ssoReplace);
  if ModalResult = mrAll then include(Result,ssoReplaceAll)
end; // TFindFrom.GetOptions

procedure TFindFrom.SwitshDialog;
begin
  if not DialogTyp then begin
    DialogTyp:=True;
    Caption:=ED;
    Label2.Enabled:=True;
    ComboBox2.Enabled:=True;
    BitBtn3.Visible:=True;
    BitBtn2.Caption:='&Ersetzten';
  end
  else begin
    DialogTyp:=False;
    Caption:=FD;
    Label2.Enabled:=False;
    ComboBox2.Enabled:=False;
    BitBtn3.Visible:=False;
    BitBtn2.Caption:='&Suchen';
  end;
end; // TFindFrom.SwitshDialog

initialization
  {$I FindDialog.lrs}

end.

