// lazarusidestrconsts
// /usr/share/icons/oxygen/16x16/actions
unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, XMLCfg, FileUtil, LResources, Forms, Controls, Graphics,Messages,strutils, OptionsDialog,
  Dialogs, Clipbrd, ComCtrls, Menus, ActnList, FileCtrl, ShellCtrls,
  SynHighlighterPas, SynEditTypes, SynHighlighterCpp, SynHighlighterJava,
  SynHighlighterPerl, SynHighlighterHTML, SynHighlighterXML, SynHighlighterLFM,
  synhighlighterunixshellscript, SynHighlighterCss, SynHighlighterPHP,
  SynHighlighterTeX, SynHighlighterSQL, SynHighlighterPython, SynHighlighterVB,
  SynEditHighlighter, SynEditSearch, SynHighlighterJScript, SynEdit,
  SynEditKeyCmds, SynMemo, LCLType, ExtCtrls, FindReplaceDialog;

type
  TPLHighlighter = record
    Caption:String;
    Highlighter,HighlighterTemp:TSynCustomHighlighter;
    SampleSourceCode:String;
  end; // THigItem

  TEditor = class(TSynEdit)
    public
      FileName, SaveCaption:String;
  end; // TEditor

  { TForm1 }
  TForm1 = class(TForm)
    AC_DEL: TAction;
    AC_AppClose: TAction;
    AC_GotoToLine: TAction;
    AC_NextFind: TAction;
    AC_Replace: TAction;
    AC_Find: TAction;
    AC_Options: TAction;
    AC_AllSel: TAction;
    AC_Cut: TAction;
    AC_Paste: TAction;
    AC_Copy: TAction;
    AC_Redo: TAction;
    AC_Undo: TAction;
    AC_ClosePages: TAction;
    AC_ClosePage: TAction;
    AC_SaveAnder: TAction;
    AC_Save: TAction;
    AC_OpenFile: TAction;
    AC_NewFile: TAction;
    ActionList1: TActionList;
    ApplicationProperties1: TApplicationProperties;
    FindDialog1: TFindDialog;
    ImageList1: TImageList;
    ImageList2: TImageList;
    Img: TImageList;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem23: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem26: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem28: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    Notebook1: TNotebook;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    XMLConfig1: TXMLConfig;
    procedure AC_AllSelExecute(Sender: TObject);
    procedure AC_AppCloseExecute(Sender: TObject);
    procedure AC_ClosePageExecute(Sender: TObject);
    procedure AC_ClosePagesExecute(Sender: TObject);
    procedure AC_CopyExecute(Sender: TObject);
    procedure AC_CutExecute(Sender: TObject);
    procedure AC_DELExecute(Sender: TObject);
    procedure AC_FindExecute(Sender: TObject);
    procedure AC_GotoToLineExecute(Sender: TObject);
    procedure AC_NewFileExecute(Sender: TObject);
    procedure AC_NextFindExecute(Sender: TObject);
    procedure AC_OpenFileExecute(Sender: TObject);
    procedure AC_OptionsExecute(Sender: TObject);
    procedure AC_PasteExecute(Sender: TObject);
    procedure AC_RedoExecute(Sender: TObject);
    procedure AC_ReplaceExecute(Sender: TObject);
    procedure AC_SaveAnderExecute(Sender: TObject);
    procedure AC_SaveExecute(Sender: TObject);
    procedure AC_UndoExecute(Sender: TObject);
    procedure ApplicationProperties1DropFiles(Sender: TObject;
      const FileNames: array of String);
    procedure FindDialog1Find(Sender: TObject);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FormDropFiles(Sender: TObject; const FileNames: array of String);
    procedure FormShow(Sender: TObject);
    procedure MenuitemClick(Sender:TObject);
    procedure Notebook1CloseTabClicked(Sender: TObject);
    procedure Notebook1PageChanged(Sender: TObject);
    procedure SynEdit1Change(Sender: TObject);
    procedure SynEdit1CommandProcessed(Sender: TObject;
      var Command: TSynEditorCommand; var AChar: TUTF8Char; Data: pointer);
    procedure SynEdit1StatusChange(Sender: TObject; Changes: TSynStatusChanges);
    procedure SynMemo1ReplaceText(Sender: TObject; const ASearch,
      AReplace: string; Line, Column: integer;
      var ReplaceAction: TSynReplaceAction);

  private
    { private declarations }
  public
    HighlighterS:array[0..14] of TPLHighlighter;
    Filter:String;
    NoMessage:Boolean;
    FindDialog:TLazFindReplaceDialog;
    PCancel:Boolean;
    function NewTab(const aCaption:WideString):TEditor;
    function FindHighlighterByExt(const ext:String):TSynCustomHighlighter;
    function ActiveEditor:TEditor;
    function FindFileName(const aFileName:String):Integer;
    procedure ActionEnabled(ACList:array of TAction; const aValue:Boolean);
    procedure ClosePage(const aIndex:Integer);
    procedure SaveToFile(const aFileName:String; aCurrEditor:TEditor);
    procedure OpenFile(const aFileName:String);
    procedure LoadParam;

    { public declarations }

  end; 

var
  Form1: TForm1; 

implementation

uses Unit3, FindDialog;

{ TForm1 }
function GetFilterIndex(const aIndex:Integer; aFilter:String):String;
var
  x,z,x1,z2:Integer;
  str:String;
begin
  z:=0; z2:=0;
  for x:=1 to Length(aFilter) do begin
    if aFilter[x] = '|' then begin
      inc(z);
      if (odd(z) and (z >= 1))  then begin
        x1:=posex('|',aFilter,x+1);
        str:=copy(aFilter,x+1,abs(x1-x-1));
        x1:=Pos(';',str);
        inc(z2);
        if x1 > 0 then str:=copy(str,1,x1-1);
      end;
      if z2 >= aIndex+1 then break;
    end;
  end; // for x

  if str = AllFilesMask then
    result:=''
  else begin
    x1:=Pos('*',str);
    if x1 > 0 then
      result:=copy(str,2,Length(str))
    else
      result:=str;
  end;
end; // GetFilterIndex

procedure TForm1.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept:=True;
end;

procedure TForm1.FormDropFiles(Sender: TObject; const FileNames: array of String
  );
begin
  writelN('TEST');
end;

procedure TForm1.FormShow(Sender: TObject);
var
  i:Integer;
  MenuItem:TMenuItem;
begin
  if HighlighterS[0].Caption <> '' then exit;
  PCancel:=False; NoMessage:=False;
  HighlighterS[0].Highlighter:=TSynFreePascalSyn.Create(nil);

  HighlighterS[0].HighlighterTemp:=TSynFreePascalSyn.Create(nil);
  HighlighterS[0].Caption:='&Pascal';
  HighlighterS[0].SampleSourceCode:=
      '{ Comment }'#13 +
      '{$R- compiler directive}'#13 +
      'procedure TForm1.Button1Click(Sender: TObject);'#13 +
      'var  // Delphi Comment'#13 +
      '  Number, I, X: Integer;'#13 +
      'begin'#13 +
      '  Number := 12345 * (2 + 9) // << Matching Brackets ;'#13 +
      '  Caption := ''The number is '' + IntToStr(Number);'#13 +
      '  asm'#13 + '    MOV AX,1234h'#13 +
      '    MOV Number,AX'#13 +
      '  end;'#13 +
      '  {%region /fold}'#13 +
      '  {%endregion}'#13 +
      '  X := 10;'#13 +
      '  inc(X); {$R+} { Search Match, Text Block }'#13 +
      '  for I := 0 to Number do {$R-} { execution point }'#13 +
      '  begin'#13 +
      '    Inc(X, 2); '#13 +
      '    Dec(X, 3); '#13 +
      '    '#13 +
      '    WriteLN(X); '#13 +
      '    X := X + 1.0; '#13 +
      '    ListBox1.Items.Add(IntToStr(X));'#13 +
      '  end;'#13 +
      'end;'#13 + #13;
  HighlighterS[1].Highlighter:=TSynCppSyn.Create(nil);
  HighlighterS[1].HighlighterTemp:=TSynCppSyn.Create(nil);
  HighlighterS[1].Caption:='&Cpp';
  HighlighterS[2].Highlighter:=TSynJavaSyn.Create(nil);
  HighlighterS[2].HighlighterTemp:=TSynJavaSyn.Create(nil);
  HighlighterS[2].Caption:='&Java';
  HighlighterS[3].Highlighter:=TSynPerlSyn.Create(nil);
  HighlighterS[3].HighlighterTemp:=TSynPerlSyn.Create(nil);
  HighlighterS[3].Caption:='P&erl';
  HighlighterS[4].Highlighter:=TSynHTMLSyn.Create(nil);
  HighlighterS[4].HighlighterTemp:=TSynHTMLSyn.Create(nil);
  HighlighterS[4].Caption:='&HTML';
  HighlighterS[5].Highlighter:=TSynXMLSyn.Create(nil);
  HighlighterS[5].HighlighterTemp:=TSynXMLSyn.Create(nil);
  HighlighterS[5].Caption:='&XML';
  HighlighterS[6].Highlighter:=TSynLFMSyn.Create(nil);
  HighlighterS[6].HighlighterTemp:=TSynLFMSyn.Create(nil);
  HighlighterS[6].Caption:='&LFM';
  HighlighterS[7].Highlighter:=TSynCssSyn.Create(nil);
  HighlighterS[7].HighlighterTemp:=TSynCssSyn.Create(nil);
  HighlighterS[7].Caption:='&CSS';
  HighlighterS[8].Highlighter:=TSynPHPSyn.Create(nil);
  HighlighterS[8].HighlighterTemp:=TSynPHPSyn.Create(nil);
  HighlighterS[8].Caption:='P&HP';
  HighlighterS[9].Highlighter:=TSynSQLSyn.Create(nil);
  HighlighterS[9].HighlighterTemp:=TSynSQLSyn.Create(nil);
  HighlighterS[9].Caption:='S&QL';
  HighlighterS[10].Highlighter:=TSynUNIXShellScriptSyn.Create(nil);
  HighlighterS[10].HighlighterTemp:=TSynUNIXShellScriptSyn.Create(nil);
  HighlighterS[10].Caption:='&UnixShellskript';
  HighlighterS[11].Highlighter:=TSynTeXSyn.Create(nil);
  HighlighterS[11].HighlighterTemp:=TSynTeXSyn.Create(nil);
  HighlighterS[11].Caption:='&TeX';
  HighlighterS[12].Highlighter:=TSynPythonSyn.Create(nil);
  HighlighterS[12].HighlighterTemp:=TSynPythonSyn.Create(nil);
  HighlighterS[12].Caption:='Pyth&on';
  HighlighterS[13].Highlighter:=TSynVBSyn.Create(nil);
  HighlighterS[13].HighlighterTemp:=TSynVBSyn.Create(nil);
  HighlighterS[13].Caption:='&VisualBasic';
  HighlighterS[14].Highlighter:=TSynJScriptSyn.Create(nil);
  HighlighterS[14].HighlighterTemp:=TSynJScriptSyn.Create(nil);
  HighlighterS[14].Caption:='Java&Script';
  Filter:='Alle Dateien(*.*)|'+AllFilesMask+'|' + 'Text Dateien(*.txt)|*.txt|';
  for i:=0 to 14 do begin
    MenuItem:=TMenuItem.Create(MenuItem27);
//    MenuItem.ImageIndex:=I;
//    MenuItem.Bitmap.Width:=24; MenuItem.Bitmap.Height:=24;
//    MenuItem.Bitmap.Canvas.FillRect(0,0,24,24);
//    ImageList2.Draw(MenuItem.Bitmap.Canvas,0,0,i);

    MenuItem.Caption:=HighlighterS[i].Caption;
    MenuItem.Tag:=i;
    MenuItem.RadioItem:=True;
    MenuItem.GroupIndex:=1;
    MenuItem.AutoCheck:=True;
    MenuItem.OnClick:=@MenuitemClick;
    MenuItem27.Add(MenuItem);
    Filter:=Filter+HighlighterS[i].Highlighter.DefaultFilter+'|';
    OptionsDialogFrm.ComboBox1.Items.Add(HighlighterS[i].Highlighter.LanguageName);
  end; // for i
  OptionsDialogFrm.ComboBox1.ItemIndex:=0;
  OptionsDialogFrm.ComboBox1Select(sender);
  OpenDialog1.Filter:=Filter; OpenDialog1.FilterIndex:=2;
  SaveDialog1.Filter:=Filter; SaveDialog1.FilterIndex:=2;
  LoadParam;
end;

procedure TForm1.AC_NewFileExecute(Sender: TObject);
begin
  NewTab('');
end; // TForm1.AC_NewFileExecute

procedure TForm1.AC_NextFindExecute(Sender: TObject);
var
  Editor:TEditor;
  SO:TSynSearchOptions;
  w:Integer;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then begin
    if Editor.SearchReplace(FindFrom.ComboBox1.Text,'',FindFrom.GetOptions) = 0 then
      ShowMessage(Format('Suchbegrieff %s wird nicht gefunden !',[FindFrom.ComboBox1.Text]));
    {w:=FindFrom.ShowModal;
    if w = mrOK then begin
      if not Editor.SearchReplace(FindFrom.ComboBox1.Text,'',FindFrom.GetOptions) then
        ShowMessage('Suchbegriff wurde nicht gefunden !');
    end;}
  end;
end;

procedure TForm1.AC_ClosePageExecute(Sender: TObject);
begin
  if Notebook1.PageIndex > -1 then ClosePage(Notebook1.PageIndex);
end; // TForm1.AC_ClosePageExecute

procedure TForm1.AC_AllSelExecute(Sender: TObject);
var
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then Editor.SelectAll;
end; // TForm1.AC_AllSelExecute

procedure TForm1.AC_AppCloseExecute(Sender: TObject);
begin
  close;
end;

procedure TForm1.AC_ClosePagesExecute(Sender: TObject);
var
  i:Integer;
  Editor:TEditor;
begin
  Form2.CheckListBox1.Items.Clear;
  for i:=Notebook1.PageCount-1 downto 0 do begin
    Editor:=TEditor(Notebook1.Page[i].controls[0]);
    if Editor.Modified then begin
      if Editor.FileName <> '' then
        Form2.CheckListBox1.Items.Add(Editor.FileName)
      else
        Form2.CheckListBox1.Items.Add(Editor.SaveCaption)
    end
    else
      Notebook1.Page[i].Destroy;
  end; // for i

  if Form2.CheckListBox1.Items.Count > 0 then begin
    Form2.Panel3.Caption:=IntToStr(Form2.CheckListBox1.Count)+ ' Ungespeicherte Dokumente. Vor dem Schließen Speichern ?';
    Form2.ModalResult:=mrNone; Form2.ShowModal;
    if (Form2.ModalResult = mrOK) or (Form2.ModalResult = mrNo) then begin
      for i:=Form2.CheckListBox1.Count-1 downto 0 do begin
        if Form2.CheckListBox1.Checked[i] then begin
          Notebook1.PageIndex:=i;
          Editor:=TEditor(Notebook1.Page[i].Controls[0]);
          if Form2.ModalResult = mrOK then begin
            //SaveToFile(Editor.FileName, Editor);
            AC_SaveAnderExecute(sender);
            if PCancel then begin
              PCancel:=False;
              exit;
            end;
          end;
          Notebook1.Page[i].Destroy;
        end;
      end; // for i
    end;
  end;
  ActionEnabled([AC_Save,AC_SaveAnder, AC_ClosePage, AC_ClosePages, AC_AllSel,AC_Find, AC_NextFind, AC_Replace, AC_GotoToLine,AC_Paste],False);
  MenuItem27.Visible:=False;
end; // TForm1.AC_ClosePagesExecute

procedure TForm1.AC_CopyExecute(Sender: TObject);
var
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then Editor.CopyToClipboard;
end; // TForm1.AC_CopyExecute

procedure TForm1.AC_CutExecute(Sender: TObject);
var
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then Editor.CutToClipboard;
end; // TForm1.AC_CutExecute

procedure TForm1.AC_DELExecute(Sender: TObject);
var
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then Editor.CommandProcessor(ecDeleteChar,'',nil);
end;

procedure TForm1.AC_FindExecute(Sender: TObject);
var
  Editor:TEditor;
  SO:TSynSearchOptions;
  w:Integer;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then begin
    FindFrom.ComboBox1.Text:=Editor.GetWordAtRowCol(Editor.LogicalCaretXY);
    w:=FindFrom.ShowModal;
    if w = mrOK then begin
      if Editor.SearchReplace(FindFrom.ComboBox1.Text,'',FindFrom.GetOptions) = 0 then
        ShowMessage(Format('Suchbegrieff %s wird nicht gefunden !',[FindFrom.ComboBox1.Text]));
    end;
  end;
end;

procedure TForm1.AC_GotoToLineExecute(Sender: TObject);
var
  str:String;
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then begin
    if InputQuery('Zu Zeile Springen','Zeile',str) then
      Editor.CaretY:=StrToInt(str);
  end;
end;

procedure TForm1.AC_OpenFileExecute(Sender: TObject);
var
  i:integer;
begin
  if OpenDialog1.Execute then begin
    for i:=0 to OpenDialog1.Files.Count-1 do begin
      OpenFile(OpenDialog1.Files[i]);
    end; // for i
  end;
//  writelN(OpenDialog1.FilterIndex)
end; // TForm1.AC_OpenFileExecute

procedure TForm1.AC_OptionsExecute(Sender: TObject);
begin
  OptionsDialogFrm.ShowModal;
end;

procedure TForm1.AC_PasteExecute(Sender: TObject);
var
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then Editor.PasteFromClipboard;
end; // TForm1.AC_PasteExecute

procedure TForm1.AC_RedoExecute(Sender: TObject);
var
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then begin
    Editor.Redo;
    ActionEnabled([AC_Redo],(Editor.CanRedo));
  end;
end; // TForm1.AC_RedoExecute

procedure TForm1.AC_ReplaceExecute(Sender: TObject);
var
  Editor:TEditor;
  so:TSynSearchOptions;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then begin
    FindFrom.SwitshDialog;
    FindFrom.ComboBox1.Text:=Editor.GetWordAtRowCol(Editor.LogicalCaretXY);
    FindFrom.ShowModal;
    case FindFrom.ModalResult of
      mrOK: begin
        so:=FindFrom.GetOptions;
        so:=so+[ssoPrompt];
        Editor.SearchReplace(FindFrom.ComboBox1.Text,FindFrom.ComboBox2.Text,so);
                                                                                       end; // mrOK

      mrAll: begin
        if FindFrom.DialogTyp then begin
          so:=so+[ssoPrompt,ssoReplaceAll];
          Editor.SearchReplace(FindFrom.ComboBox1.Text,FindFrom.ComboBox2.Text,so);
        end;
      end;
    end; // case
    FindFrom.SwitshDialog
  end;
end;

procedure TForm1.AC_SaveAnderExecute(Sender: TObject);
var
  CurrEditor:TEditor;
  ext:String;
begin
  CurrEditor:=ActiveEditor;
  if Assigned(CurrEditor) then begin
    if SaveDialog1.Execute then begin
      if pos('.',SaveDialog1.FileName) = 0 then
        CurrEditor.FileName:=SaveDialog1.FileName+GetFilterIndex(SaveDialog1.FilterIndex-1,SaveDialog1.Filter)
      else
        CurrEditor.FileName:=SaveDialog1.FileName;
      CurrEditor.SaveCaption:=ExtractFileName(CurrEditor.FileName);

      Notebook1.ActivePage:=CurrEditor.SaveCaption;
      AC_SaveExecute(Sender);
    end
    else
      PCancel:=True;
  end
  else
    ShowMessage('Keine Dokument geladen !');
end; // TForm1.AC_SaveAnderExecute

procedure TForm1.AC_SaveExecute(Sender: TObject);
var
  CurrEditor:TEditor;
begin
  CurrEditor:=ActiveEditor;
  if Assigned(CurrEditor) then begin
    if (not NoMessage) and (CurrEditor.FileName = '') then
      AC_SaveAnderExecute(Sender)
    else begin
      SaveToFile(CurrEditor.FileName,CurrEditor);
    end;
  end
  else
    ShowMessage('Keine Dokument geladen !');
end; // TForm1.AC_SaveExecute

procedure TForm1.AC_UndoExecute(Sender: TObject);
var
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
  if Assigned(Editor) then begin
    Editor.Undo;
    ActionEnabled([AC_Undo],(Editor.CanUndo));
  end;
end; // TForm1.AC_UndoExecute

procedure TForm1.ApplicationProperties1DropFiles(Sender: TObject;
  const FileNames: array of String);
var
  i:Integer;
begin
  for i:=0 to Length(FileNames) do
    OpenFile(FileNames[i]);
end;

procedure TForm1.FindDialog1Find(Sender: TObject);
var
  Editor:TEditor;
begin
  Editor:=ActiveEditor;
end;

procedure TForm1.MenuitemClick(Sender: TObject);
var
  MenuItem:TMenuItem;
  Editor:TEditor;
begin
  MenuItem:=(Sender as TMenuItem);
  Editor:=ActiveEditor;
  if Assigned(Editor) then begin
    Editor.Highlighter:=HighlighterS[MenuItem.Tag].Highlighter;
  end;
end; // TForm1.MenuitemClick

procedure TForm1.Notebook1CloseTabClicked(Sender: TObject);
begin
  if Notebook1.PageIndex > -1 then
  ClosePage(Notebook1.PageIndex);
end; // Notebook1CloseTabClicked

procedure TForm1.Notebook1PageChanged(Sender: TObject);
var
  CurrEditor:TEditor;
begin
  CurrEditor:=ActiveEditor;
  if Assigned(CurrEditor) then begin
    StatusBar1.Panels[0].Text:=Format('%d:%d',[CurrEditor.CaretY, CurrEditor.CaretX]);
    if CurrEditor.Modified then
      StatusBar1.Panels[1].Text:='Geändert'
    else
      StatusBar1.Panels[1].Text:='';
    StatusBar1.Panels[2].Text:=CurrEditor.FileName;
  end;
end; // TForm1.Notebook1PageChanged

procedure TForm1.SynEdit1Change(Sender: TObject);
var
  CurrEditor:TEditor;
begin
  CurrEditor:=ActiveEditor;
  if Assigned(CurrEditor) then begin
    Notebook1.Page[Notebook1.PageIndex].Caption:=CurrEditor.SaveCaption + '*';
    StatusBar1.Panels[1].Text:='Geändert';
  end
  else
    ShowMessage('Keine Seite geladen !');
end; // TForm1.SynEdit1Change

procedure TForm1.SynEdit1CommandProcessed(Sender: TObject;
  var Command: TSynEditorCommand; var AChar: TUTF8Char; Data: pointer);
var
  s:String;
  Editor:TEditor;
begin
  s:=EditorCommandToCodeString(Command);
  if pos('Sel', s) > 0 then begin
    if not AC_Cut.Enabled then begin
      ActionEnabled([AC_Cut, AC_Copy, AC_DEL],True);
    end;
  end
  else begin
    if AC_Cut.Enabled then ActionEnabled([AC_Cut, AC_Copy,AC_DEL],False);
  end;
  editor:=TEditor(Sender);
  ActionEnabled([AC_Undo],(Editor.CanUndo));
  ActionEnabled([AC_Redo],(Editor.CanRedo));
end; // TForm1.SynEdit1CommandProcessed

procedure TForm1.SynEdit1StatusChange(Sender: TObject;
  Changes: TSynStatusChanges);
var
  Editor:TEditor;
begin
  Editor:=TEditor(Sender);
  if (Changes*[scAll, scCaretX, scCaretY]<>[]) then begin
    StatusBar1.Panels[0].Text:=Format('%d:%d',[Editor.CaretY, Editor.CaretX]);
  end;
  ActionEnabled([AC_Cut, AC_Copy,AC_DEL],Editor.SelText <> '')
end; // TForm1.SynEdit1StatusChange

procedure TForm1.SynMemo1ReplaceText(Sender: TObject; const ASearch,
  AReplace: string; Line, Column: integer; var ReplaceAction: TSynReplaceAction
  );
var
  w:Integer;
begin
  w:=MessageDlg('Wirklich ersetzten ?','Wirklich ersetzten ?',mtWarning,[mbYes, mbNo,mbCancel,mbYesToAll],'');
  writeln('TEST:',w);
  case w of
    mrCancel:ReplaceAction:=raCancel;
    mrNo:ReplaceAction:=raSkip;
    mrYes:ReplaceAction:=raReplace;
    mrYesToAll:begin
      ReplaceAction:=raReplaceAll;
    end;
  end; // w
end;


procedure TForm1.ActionEnabled(ACList: array of TAction; const aValue: Boolean
  );
var
  i:Integer;
begin
  for i:=0 to Length(ACList)-1 do begin
    ACList[i].Enabled:=aValue;
  end; // for i
end; // TForm1.ActionEnabled

function TForm1.NewTab(const aCaption: WideString):TEditor;
var
  Page:TPage;
  Editor:TEditor;
begin
  Page:=TPage.Create(Notebook1);
  if aCaption = '' then begin
    Page.Caption:='Unbekannt';
    Page.Tag:=1;
  end
  else
    Page.Caption:=aCaption;
  page.Parent:=Notebook1;

  Editor:=TEditor.Create(Page);
  Editor.FileName:='';
  Editor.SaveCaption:=Page.Caption;
  Editor.Align:=alClient;
  Editor.Parent:=Page;
  Editor.OnChange:=@SynEdit1Change;
  Editor.OnCommandProcessed:=@SynEdit1CommandProcessed;
  Editor.OnStatusChange:=@SynEdit1StatusChange;
  Editor.BookMarkOptions.BookmarkImages:=ImageList1;
  Editor.OnReplaceText:=@SynMemo1ReplaceText;
  result:=Editor;
  Notebook1.ActivePage:=Page.Caption;
  ActionEnabled([AC_Save,AC_SaveAnder, AC_ClosePage, AC_ClosePages, AC_AllSel,AC_Find, AC_NextFind, AC_Replace, AC_GotoToLine],True);
  if Length(Clipboard.AsText) > 0 then ActionEnabled([AC_Paste],True);
  MenuItem27.Visible:=True;
end; // TForm1.NewTab

function TForm1.FindHighlighterByExt(const ext: String):TSynCustomHighlighter;
var
  i,z:Integer;
begin
  z:=-1;
  for i:=0 to 14 do begin
    if pos(ext,upperCase(HighlighterS[i].Highlighter.DefaultFilter)) > 0 then begin
      z:=i;
      break;
    end;
  end; // for i
  if z > -1 then
    result:=HighlighterS[z].Highlighter
  else
    result:=nil;
end; // TForm1.FindHighlighterByExt

function TForm1.ActiveEditor: TEditor;
begin
  if Notebook1.PageIndex > -1 then begin
    result:=TEditor(Notebook1.Page[Notebook1.PageIndex].Controls[0]);
  end
  else
    result:=nil;
end; // TForm1.ActiveEditor

function TForm1.FindFileName(const aFileName: String): Integer;
var
  i,z:Integer;
  Editor:TEditor;
begin
  z:=-1;
  for i:=0 to Notebook1.PageCount-1 do begin
    Editor:=(Notebook1.Page[i].Controls[0] as TEditor);
    if Editor.FileName = aFileName then begin
      z:=i;
      break;
    end;
  end; // for i
  result:=z;
end; // TForm1.FindFileName

procedure TForm1.ClosePage(const aIndex: Integer);
var
  CurrEditor:TEditor;
  w:Integer;
begin
  CurrEditor:=ActiveEditor;
  if Assigned(CurrEditor) then begin
    if (not NoMessage) and (CurrEditor.Modified) then begin
      w:=MessageDlg ('Speichern ?', 'Das Dokument '+CurrEditor.SaveCaption+' wurde noch nicht gespeichert !', mtWarning, [mbYes, mbNo, mbCancel],0);
      if w = mrYes then begin
        AC_SaveExecute(Self);
        if PCancel then begin
          PCancel:=False;
          exit;
        end;
      end;
      if w = mrCancel then exit;
    end;
  end;
  Notebook1.Page[aIndex].Destroy;
  if Notebook1.PageCount = 0 then begin
    ActionEnabled([AC_Save,AC_SaveAnder, AC_ClosePage, AC_ClosePages, AC_AllSel,AC_Find, AC_NextFind, AC_Replace, AC_GotoToLine, AC_Paste],False);
    MenuItem27.Visible:=False;
  end;
end; // TForm1.ClosePage

procedure TForm1.SaveToFile(const aFileName: String; aCurrEditor:TEditor);
begin
  aCurrEditor.Lines.SaveToFile(aCurrEditor.FileName);
  Notebook1.Page[Notebook1.PageIndex].Caption:=aCurrEditor.SaveCaption;
  StatusBar1.Panels[1].Text:='Unverändert';
  Notebook1PageChanged(self);
end; // TForm1.SaveToFile

procedure TForm1.OpenFile(const aFileName: String);
var
  h:TSynCustomHighlighter;
  z:Integer;
begin
  if FileIsText(aFileName) then begin
    z:=FindFileName(aFileName);
    if z = -1 then begin
      with NewTab(ExtractFileName(aFileName)) do begin
        Lines.LoadFromFile(aFileName);
        FileName:=aFileName;
        h:=FindHighlighterByExt(UpperCase(ExtractFileExt(ExtractFileName(aFileName))));
        if Assigned(h) then Highlighter:=h
      end; // with
    end
    else
      Notebook1.PageIndex:=z;
    Notebook1PageChanged(Self);
  end;
end; // TForm1.OpenFIle

procedure TForm1.LoadParam;
var
  i:Integer;
begin
  for i:=1 to Paramcount do OpenFile(ParamStr(i));
end; // TForm1.LoadParam

initialization
  {$I Unit1.lrs}

end.

